import 'package:flutter/material.dart';

class AppColorSchemes {
  AppColorSchemes({
    required this.main,
    required this.secondary,
    required this.title,
    required this.subtitle,
    required this.clickable,
  });

  final Color main;
  final Color secondary;
  final Color title;
  final Color subtitle;
  final Color clickable;

  static ColorScheme blackAndWhiteLight() {
    return const ColorScheme(
      brightness: Brightness.light,
      primary: Colors.white,
      onPrimary: Colors.black,
      secondary: Colors.white,
      onSecondary: Colors.black,
      tertiary: Colors.blue,
      onTertiary: Colors.white,
      tertiaryContainer: Colors.white,
      onTertiaryContainer: Colors.blue,
      background: Colors.white,
      onBackground: Colors.black,
      surface: Colors.white,
      onSurface: Colors.black,
      error: Colors.white,
      onError: Colors.red,
      errorContainer: Colors.red,
      onErrorContainer: Colors.white,
    );
  }

  static ColorScheme blackAndWhiteDark() {
    return const ColorScheme(
      brightness: Brightness.dark,
      primary: Colors.black,
      onPrimary: Colors.white,
      secondary: Colors.black,
      onSecondary: Colors.white,
      tertiary: Colors.blue,
      onTertiary: Colors.white,
      tertiaryContainer: Colors.blue,
      onTertiaryContainer: Colors.white,
      background: Colors.black,
      onBackground: Colors.white,
      surface: Colors.black,
      onSurface: Colors.white,
      error: Colors.black,
      onError: Colors.red,
      errorContainer: Colors.red,
      onErrorContainer: Colors.white,
    );
  }
}
