import 'package:http/http.dart' as http;
import 'package:modular_system_core/mscore.dart';

class AuthenticationController extends WebController {
  AuthenticationController({required String baseUri, required this.controllerName}) : super(baseUri: baseUri);

  final String controllerName;

  @override
  String getUri() {
    return "$baseUri/api/$controllerName";
  }

  Future<String> authenticateAsync(CredentialHandshake handshake) async {
    var resp = await http.post(
      Uri.parse("${getUri()}/authenticate"),
      headers: <String, String>{
        'Content-Type': 'application/json',
      },
      body: handshake.toJson(),
    );
    var jsonMap = getJsonFrom(resp);
    return StringDTO.fromJson(jsonMap).value;
  }
}
