import 'dart:convert';
import 'package:modular_system_core/mscore.dart';

enum CurrencyEnum {
  custom,
  usd,
  brl,
  btc,
  eur,
}

class CurrencyValue implements JsonSerializer<CurrencyValue> {
  CurrencyValue();

  factory CurrencyValue.fromJson(Map<String, dynamic> jsonMap) {
    var i = CurrencyValue();
    i.name = jsonMap["name"];
    i.code = jsonMap["code"];
    i.symbol = jsonMap["symbol"];
    i.coin = CurrencyEnum.values[jsonMap["enum"]];
    i.value = jsonMap["value"];
    return i;
  }

  String name = "";
  String code = "";
  String symbol = "";
  CurrencyEnum coin = CurrencyEnum.brl;
  double value = 0;

  @override
  CurrencyValue fromJson(Map<String, dynamic> jsonMap) {
    var i = CurrencyValue();
    i.name = jsonMap["name"];
    i.code = jsonMap["code"];
    i.symbol = jsonMap["symbol"];
    i.coin = CurrencyEnum.values[jsonMap["enum"]];
    i.value = jsonMap["value"];
    return i;
  }

  @override
  String toJson() => jsonEncode(toJsonMap());

  @override
  Map<String, dynamic> toJsonMap() {
    return {
      "name": name,
      "code": code,
      "symbol": symbol,
      "coin": coin.index,
      "value": value,
    };
  }

  @override
  String toString() {
    var str = value.toStringAsFixed(2);
    if (symbol.isNotEmpty) {
      str = '$symbol $str';
    }
    return str;
  }
}
