import 'dart:convert';

import 'package:modular_system_core/mscore.dart';

class DateOfBirth implements JsonSerializer<DateOfBirth> {
  DateOfBirth();

  int day = 0;
  int month = 0;
  int year = 0;

  factory DateOfBirth.fromJson(Map<String, dynamic> jsonMap) {
    var i = DateOfBirth();
    i.day = jsonMap["day"];
    i.month = jsonMap["month"];
    i.year = jsonMap["year"];
    return i;
  }

  String toStringBrazil() {
    var day = this.day < 10 ? "0${this.day}" : "${this.day}";
    var month = this.month < 10 ? "0${this.month}" : "${this.month}";
    return "${day}/${month}/${this.year}";
  }

  @override
  Map<String, dynamic> toJsonMap() {
    return {
      'day': day,
      'month': month,
      'year': year,
    };
  }

  @override
  DateOfBirth fromJson(Map<String, dynamic> jsonMap) {
    var i = DateOfBirth();
    i.day = jsonMap["day"];
    i.month = jsonMap["month"];
    i.year = jsonMap["year"];
    return i;
  }

  @override
  String toJson() => jsonEncode(toJsonMap());
}
