import 'dart:convert';
import 'package:modular_system_core/mscore.dart';

abstract class DTO<T> {
  DTO({required this.value});

  T value;
}

class StringDTO extends DTO<String> implements JsonSerializer<StringDTO> {
  StringDTO(String value) : super(value: value);

  factory StringDTO.fromJson(Map<String, dynamic> jsonMap) {
    return StringDTO(jsonMap["value"]);
  }

  static StringDTO from(String value) => StringDTO(value);

  @override
  StringDTO fromJson(Map<String, dynamic> jsonMap) {
    return StringDTO(jsonMap["value"]);
  }

  @override
  Map<String, dynamic> toJsonMap() {
    return {"value": value};
  }

  @override
  String toJson() => jsonEncode(toJsonMap());
}

class BooleanDTO extends DTO<bool> implements JsonSerializer<BooleanDTO> {
  BooleanDTO(bool value) : super(value: value);

  factory BooleanDTO.fromJson(Map<String, dynamic> jsonMap) {
    return BooleanDTO(jsonMap["value"]);
  }

  static BooleanDTO from(bool value) => BooleanDTO(value);

  @override
  BooleanDTO fromJson(Map<String, dynamic> jsonMap) {
    return BooleanDTO(jsonMap["value"]);
  }

  @override
  Map<String, dynamic> toJsonMap() {
    return {"value": value};
  }

  @override
  String toJson() => jsonEncode(toJsonMap());
}

class IntDTO extends DTO<int> implements JsonSerializer<IntDTO> {
  IntDTO(int value) : super(value: value);

  factory IntDTO.fromJson(Map<String, dynamic> jsonMap) {
    return IntDTO(jsonMap["value"]);
  }

  static BooleanDTO from(bool value) => BooleanDTO(value);

  @override
  IntDTO fromJson(Map<String, dynamic> jsonMap) {
    return IntDTO(jsonMap["value"]);
  }

  @override
  Map<String, dynamic> toJsonMap() {
    return {"value": value};
  }

  @override
  String toJson() => jsonEncode(toJsonMap());
}

class DoubleDTO extends DTO<double> implements JsonSerializer<DoubleDTO> {
  DoubleDTO(double value) : super(value: value);

  factory DoubleDTO.fromJson(Map<String, dynamic> jsonMap) {
    return DoubleDTO(jsonMap["value"]);
  }

  static BooleanDTO from(bool value) => BooleanDTO(value);

  @override
  DoubleDTO fromJson(Map<String, dynamic> jsonMap) {
    return DoubleDTO(jsonMap["value"]);
  }

  @override
  Map<String, dynamic> toJsonMap() {
    return {"value": value};
  }

  @override
  String toJson() => jsonEncode(toJsonMap());
}

class DynamicDTO extends DTO<dynamic> implements JsonSerializer<DynamicDTO> {
  DynamicDTO(dynamic value) : super(value: value);

  factory DynamicDTO.fromJson(Map<String, dynamic> jsonMap) {
    return DynamicDTO(jsonMap["value"]);
  }

  static BooleanDTO from(bool value) => BooleanDTO(value);

  @override
  DynamicDTO fromJson(Map<String, dynamic> jsonMap) {
    return DynamicDTO(jsonMap["value"]);
  }

  @override
  Map<String, dynamic> toJsonMap() {
    return {"value": value};
  }

  @override
  String toJson() => jsonEncode(toJsonMap());
}
