import 'dart:convert';
import 'package:modular_system_core/mscore.dart';

class LegalDocument implements JsonSerializer<LegalDocument> {
  LegalDocument();

  factory LegalDocument.fromJson(Map<String, dynamic> jsonMap) {
    var i = LegalDocument();
    i.number = jsonMap['number'];
    i.issuedBy = jsonMap['issuedBy'];
    i.validUntil = DateTime.parse(jsonMap['validUntil']);
    return i;
  }

  String number = "";
  String issuedBy = "";
  DateTime validUntil = DateTime.now();

  @override
  LegalDocument fromJson(Map<String, dynamic> jsonMap) =>
      LegalDocument.fromJson(jsonMap);

  @override
  String toJson() => jsonEncode(toJsonMap());

  @override
  Map<String, dynamic> toJsonMap() {
    return {
      'number': number,
      'issuedBy': issuedBy,
      'validUntil': validUntil.toIso8601String(),
    };
  }
}
