import 'dart:convert';
import 'package:modular_system_core/mscore.dart';

class PaginationIn implements JsonSerializer<PaginationIn> {
  PaginationIn({
    this.offset = 0,
    this.limit = 30,
  });

  factory PaginationIn.fromJson(Map<String, dynamic> jsonMap) {
    return PaginationIn(
      offset: jsonMap["offset"],
      limit: jsonMap["limit"],
    );
  }

  factory PaginationIn.empty() {
    return PaginationIn(
      offset: 0,
      limit: 0,
    );
  }

  factory PaginationIn.fromLimit([int limit = 30]) {
    return PaginationIn(
      offset: 0,
      limit: limit,
    );
  }

  int offset;
  int limit;

  @override
  PaginationIn fromJson(Map<String, dynamic> jsonMap) {
    return PaginationIn(
      offset: jsonMap["offset"],
      limit: jsonMap["limit"],
    );
  }

  @override
  Map<String, dynamic> toJsonMap() {
    return {
      "offset": offset,
      "limit": limit,
    };
  }

  @override
  String toJson() => jsonEncode(toJsonMap());
}

class PaginationOut implements JsonSerializer<PaginationOut> {
  PaginationOut({
    this.offset = 0,
    this.limit = 0,
    this.total = 0,
  });

  factory PaginationOut.empty() {
    return PaginationOut(
      offset: 0,
      limit: 0,
      total: 0,
    );
  }

  factory PaginationOut.fromLimit([int limit = 30]) {
    return PaginationOut(
      offset: 0,
      limit: limit,
      total: 0,
    );
  }

  factory PaginationOut.fromJson(Map<String, dynamic> jsonMap) {
    return PaginationOut(
      offset: jsonMap["offset"],
      limit: jsonMap["limit"],
      total: jsonMap["total"],
    );
  }
  int offset;
  int limit;
  int total;

  @override
  PaginationOut fromJson(Map<String, dynamic> jsonMap) {
    return PaginationOut(
      offset: jsonMap["offset"],
      limit: jsonMap["limit"],
      total: jsonMap["total"],
    );
  }

  @override
  Map<String, dynamic> toJsonMap() {
    return {
      "offset": offset,
      "limit": limit,
      "total": total,
    };
  }

  @override
  String toJson() => jsonEncode(toJsonMap());
}
