import 'dart:convert';
import 'package:modular_system_core/mscore.dart';

class PhoneNumber implements JsonSerializer<PhoneNumber> {
  PhoneNumber();

  factory PhoneNumber.fromJson(Map<String, dynamic> jsonMap) {
    var i = PhoneNumber();
    i.countryCode = jsonMap['countryCode'];
    i.areaCode = jsonMap['areaCode'];
    i.number = jsonMap['number'];
    return i;
  }

  String countryCode = "";
  String areaCode = "";
  String number = "";

  @override
  PhoneNumber fromJson(Map<String, dynamic> jsonMap) =>
      PhoneNumber.fromJson(jsonMap);

  @override
  String toJson() => jsonEncode(toJsonMap());

  @override
  Map<String, dynamic> toJsonMap() {
    return {
      'countryCode': countryCode,
      'areaCode': areaCode,
      'number': number,
    };
  }

  @override
  String toString() {
    return toStringInternational();
  }

  String toStringInternational() {
    return "+$countryCode ($areaCode) $number";
  }

  String toStringNational() {
    return "($areaCode) $number";
  }

  String toStringLocal() {
    return number;
  }
}
