import 'package:modular_system_core/mscore.dart';

class ReactiveObject<T> {
  SetEvent<T> stateChangedEvent = SetEvent();

  void notify() {
    stateChangedEvent.invoke(this as T);
  }

  void subscribe(Function(T) callback) {
    stateChangedEvent.subscribe(callback);
  }

  void unsubscribe(Function(T) callback) {
    stateChangedEvent.unsubscribe(callback);
  }
}
