import 'package:flutter/material.dart';
import 'package:modular_system_core/mscore.dart';
import 'package:modular_system_core/src/infra/app_viewmodel.dart';

class TableExtraOptions extends StatefulWidget {
  // ignore: use_key_in_widget_constructors
  const TableExtraOptions({
    required this.appViewModel,
    required this.viewModel,
    required this.child,
  });

  final AppViewModel appViewModel;
  final EntityTableViewModel viewModel;
  final Widget? child;

  @override
  State<TableExtraOptions> createState() {
    // ignore: no_logic_in_create_state
    return _TableExtraOptionsState(
      appViewModel: appViewModel,
      viewModel: viewModel,
      child: child,
    );
  }
}

class _TableExtraOptionsState extends State<TableExtraOptions> {
  _TableExtraOptionsState({
    required this.appViewModel,
    required this.viewModel,
    required this.child,
    this.extraOptionsBuilder,
  }) {
    viewModel.events.showExtraOptionsEvent.subscribe(onShowExtraOptions);
  }

  @override
  void dispose() {
    viewModel.events.showExtraOptionsEvent.unsubscribe(onShowExtraOptions);
    super.dispose();
  }

  final AppViewModel appViewModel;
  final EntityTableViewModel viewModel;
  final Widget? child;
  final Widget Function(AppViewModel avm, EntityTableViewModel vm)? extraOptionsBuilder;
  late bool show = viewModel.state.extraOptionsOn;

  @override
  Widget build(BuildContext context) {
    if (!show) {
      return Container();
    }
    return child ?? Container();
  }

  void onShowExtraOptions(dynamic data) {
    setState(() {
      show = viewModel.state.extraOptionsOn;
    });
  }
}
