import 'dart:math';
import 'package:flutter/material.dart';

class LayoutConstraint {
  LayoutConstraint({
    required this.context,
    required this.boxConstraints,
  }) {
    hypotenuse = getHypotenuse();
  }

  late double hypotenuse;
  BuildContext context;
  BoxConstraints boxConstraints;

  double getHypotenuse() {
    return sqrt(
        pow(boxConstraints.maxWidth, 2) + pow(boxConstraints.maxHeight, 2));
  }

  double percentageWidth(double percentage) {
    if (percentage > 1) {
      percentage = percentage * 0.01;
    }
    return hypotenuse * percentage;
  }

  double percentageHeight(double percentage) {
    if (percentage > 1) {
      percentage = percentage * 0.01;
    }
    return hypotenuse * percentage;
  }
}

class LayoutFrame extends StatelessWidget {
  // ignore: use_key_in_widget_constructors
  const LayoutFrame({
    required this.builder,
  });

  final Widget Function(BuildContext context, LayoutConstraint constraints)
      builder;

  @override
  Widget build(BuildContext _context) {
    return LayoutBuilder(
      builder: (context, boxConstraints) {
        var constraints = LayoutConstraint(
          context: context,
          boxConstraints: boxConstraints,
        );
        return builder.call(context, constraints);
      },
    );
  }
}
